// Copyright (c) 2008, NTT DATA Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using TERASOLUNA.Fw.Common.Logging;

namespace TERASOLUNA.Fw.Web.Configuration.ExceptionCode
{
    /// <summary>
    /// エラー画面遷移設定ファイルから ExceptionTransitionConfiguration 設定情報を取得します。
    /// </summary>
    public abstract class ExceptionCodeConfiguration
    {
        /// <summary>
        /// <see cref="ILog"/> 実装クラスのインスタンスです。
        /// </summary>
        /// <remarks>
        /// ログ出力に利用します。
        /// </remarks>
        private static ILog _log = LogFactory.GetLogger(typeof(ExceptionCodeConfiguration));

        /// <summary>
        /// 指定された例外に対応する例外コードを取得します。
        /// </summary>
        /// <param name="type">例外の <see cref="Type"/> 。</param>
        /// <returns>
        /// <paramref name="type"/> に指定された例外に対応する例外コード。
        /// 対応する例外コードが存在しない場合は null 参照。
        /// </returns>
        /// <remarks>
        /// 例外コード設定ファイルから、<paramref name="type"/> の値に対応する code 属性の値を取得します。
        /// 対応する code 属性の値が存在しない場合、null 参照を返します。
        /// </remarks>
        /// <exception cref="ArgumentNullException">
        /// <paramref name="type"/> が null 参照です。
        /// </exception>
        /// <exception cref="System.Configuration.ConfigurationErrorsException">
        /// 構成ファイルを読み込むことができません。
        /// </exception>
        public static string GetCode(Type type)
        {
            if (type == null)
            {
                ArgumentNullException exception = new ArgumentNullException("type");
                if (_log.IsErrorEnabled)
                {
                    _log.Error(string.Format(
                        Properties.Resources.E_NULL_ARGUMENT, "type"), exception);
                }
                throw exception;
            }

            string ret = null;

            ExceptionCodeConfigurationSection eccs = TerasolunaWebConfiguration.ExceptionCodeConfigSection;
            if (eccs != null)
            {
                ExceptionCodeElement element = eccs.ExceptionCodeCollection[type.FullName];
                if (element != null)
                {
                    ret = element.Code;
                }
            }

            return ret;
        }

        /// <summary>
        /// 指定された例外に対する 例外コード を取得します。
        /// </summary>
        /// <remarks>
        /// 指定された例外インスタンスの完全クラス名称をキーとし、例外コード設定ファイル
        /// から例外コードを取得します。
        /// 対象の例外コード設定が見つからない場合はベースクラスの例外完全クラス名称を取得し、
        /// 再度検索を試みます。
        /// <see cref="Exception"/> に至るまでに対応する例外コードを取得できなかった
        /// 場合は null を返却します。
        /// </remarks>
        /// <param name="ex">
        /// <see cref="System.Exception"/> オブジェクト。
        /// </param>
        /// <returns>
        /// <paramref name="ex"/> に指定された例外に対応する例外コード。
        /// 対応する例外コードが存在しない場合は null 参照を返却します。
        /// </returns>
        /// <exception cref="ArgumentNullException">
        /// <paramref name="ex"/> が null 参照です。
        /// </exception>
        /// <exception cref="System.Configuration.ConfigurationErrorsException">
        /// 構成ファイルを読み込むことができませんでした。
        /// </exception>
        public static string GetExceptionCode(Exception ex)
        {
            if (ex == null)
            {
                ArgumentNullException exception = new ArgumentNullException("ex");
                if (_log.IsErrorEnabled)
                {
                    _log.Error(string.Format(
                        Properties.Resources.E_NULL_ARGUMENT, "ex"), exception);
                }
                throw exception;
            }

            Type t = ex.GetType();

            string code = null;

            while (t != null)
            {
                code = GetCode(t);
                if (code != null)
                {
                    break;
                }
                t = t.BaseType;
            }

            if (_log.IsTraceEnabled)
            {
                if (code == null)
                {
                    string message = string.Format(
                        Properties.Resources.T_EXCEPTION_CODE_CONFIGURATION_NOT_LOAD_PARAMETER, ex.GetType().FullName);
                    _log.Trace(message);
                }
                else
                {
                    string message = string.Format(
                        Properties.Resources.T_EXCEPTION_CODE_CONFIGURATION_LOAD_PARAMETER, ex.GetType().FullName, code);
                    _log.Trace(message);
                }
            }
            return code;
        }
    }
}
